What should have been in the LZH file:

     DMJ_GIF.PRG    The program, version 2.0.
     DMJ_GIF.MAN    This file.
     SPU2SPC.PRG    A program to convert SPU pics to SPC.
     SPC_3375.PRG   A program to view STe Spectrum pictures on an ST.

There might also be a Spectrum picture or two in the LZH file.

This program is Shareware.  To register your copy of the program, please
send $10 to:

      Damien M. Jones
      P.O. Box 657
      APO New York, NY 09109

In return for registering this program, you will be place on my registered
user list, and you will receive free updates for as long as the program
survives.  You will also receive (free) disks with new programs as they
are released, although you will have to register those separately.

What this is:

You mean you haven't heard about this awesome program yet?
Haven't you been reading Z*Net?

This is a program that converts GIF pictures to Spectrum format.
Granted, this is not the first program that does that.  But what
this program does that other programs don't do is scale large
pictures (i.e. 640x400) very well.

Here's why: most programs (or should I say, every single program
I've ever used except the Spectrum paint program itself) don't
scale things very well.  Let's say, for example, that you want to
convert a picture that's 640x400x16 colors down to a picture
that's 320x200x512.  What you'd do is divide the entire screen up
into little squares--each square being 2x2 pixels.  Most programs
look at each little square and pick one of the points, assuming
it best represents the entire square.  That's usually no problem,
but if you've got a lot of patterns and "dithering", then you do
have a problem, because you're leaving out 75% of the detail
while preserving the other 25%.  What you end up with is usually
a mess.

This program takes a different approach.  Instead of just picking
one pixel from that 2x2 square, it determines the overall color
by averaging the colors of the pixels.  (That's why you need 512
colors--when you start averaging 16 colors with different amounts
of each one, the number of colors gets big, fast.  One 16-color
picture I reduced had over 200 colors in it when it was done.)
Of course, with fantastic results there comes a price.  The price
with this program is speed.  Because of the averaging and the
floating point (read "slow") arithmetic, this program takes a
while to run.  But the results are WELL worth the wait.

Using the program:

You can run the program from medium or low res.  Once it is
loaded, select the GIF file you wish to convert.  Then select the
destination file.  You can enter either SPU or SPC as the
extension, and the program will save accordingly.  (SPU is
uncompressed, SPC is compressed.)  The program will read in some
of the information from the file and determine what scaling
should be done.  The X reduction factor is the horizontal
scaling; the Y reduction factor is the vertical scaling.  So if
you had a picture that is 640x200, you'd have an X reduction
factor of 2 (because 640/2=320) and a Y reduction factor of 1
(because 200/1=200).  A picture that is 640x480 has default
factors of 2 and 2.4.  No matter what the factors are, you will
be asked if you want to change them.  If you do, select "Yes"
from the alert box and enter the numbers.  You may enter any
scaling factor you like, as long as it is at least 1; at the
moment you cannot magnify pictures with this program.  You can
enter fractional values if you like; they will be used properly.

Now you will be asked whether or not to use the STe palette.  The
STe can use 4,096 colors, whereas the ST can only use 512.  If
you have an STe (or something that lets you emulate the STe's
4,096 colors) select "Yes"; select "No" to use the regular palette
of 512 colors.  After choosing the palette, you will be asked how
much dithering to use.  The ST has 512 (4,096 for STe) colors to
choose from.  This is actually quite a few.  But sometimes pictures
use very small differences in color that don't show up with only 512
(or even 4,096) colors. By using low dithering, you increase that
range to 3,375 (29,791 for STe).  And high dithering increases the
range to 19,683 (226,981 for STe).  But you should be aware that
not all pictures look better with dithering on.  If the picture
doesn't turn out well with dithering on, try turning it off, or use
use less dithering.

Now the GIF file will be read in, and the picture converted.  If
the picture is interlaced and there isn't enough memory for the
entire uncompressed bitmap, the program will need to write a
temporary file to the disk.  This temporary file may be as big as
300K; use the alert box to choose the drive you want the temporary
file to be stored on (by using the <- and -> buttons) and select
the center box when you're satisfied.  Then hit either Yes or No
at the next alert box to confirm your choice.

Then, after a moderately long wait (about 20 minutes is usually
the longest) the picture will be saved to disk, and then
displayed on the screen.  (This is so you don't have to quit and
load up a picture viewer just to see your new awesome picture.)
Simply press any key to remove the picture from the screen, and
you can again select a GIF file to convert.  If you wish to quit,
just select "Cancel" from one of the fileselectors.

Notes:

o DMJ GIF maintains two separate paths, one for the source files
  (GIF's) and one for the destination files (Spectrum pictures).
o The default selection for "Use STe palette" will be based on
  whether or not you are currently using an STe.
o The program will automatically default to the "best" dithering
  mode for the picture, based on the contrast of the colors.
  (This does take into account the palette selected.)
o The program will only ask for the drive for the temporary
  file once.  If you convert any more interlaced pictures before
  exiting the program, it will use the same drive for the temporary
  file.
o You can abort the conversion at any time by pressing a key.  The
  program may not seem to respond immediately, but should in less
  than ten seconds.
o If (for some unfathomable reason) the program crashes while
  working on an interlaced GIF, you may find the temporary file
  (DMJGIF20.TMP) still exists.  You should delete this to free up
  the disk space.

Version 2.0 already?

Yes, I know this is only the second release of the program, but
its capabilities have been expanded so much that I thought it
deserved a whole new version number.  If you don't agree, well...
tough.  (Grin)

Revisions from version 1.0:

The program released on GEnie was a Beta version of the program.
It was not supposed to be released because it was not finished.
The following are items that were not complete in the previous
program:

o The B program (for handling interlaced GIF's) was not done
  at all, so it wasn't even in the .LZH that was released.  It
  has been incorporated into this (2.0) version, eliminating the
  need for a second program.
o A major bug causing pictures saved in compressed (SPC) format
  to be saved incorrectly has been fixed.  So, save them compressed
  if you can, it REALLY saves disk space!
o The original (incomplete) manual made reference to View-All.
  This program is still not complete.  As soon as it is, it will be
  released.

Releasing the Beta version was NOT my idea.  But since it worked out
all right, I guess I don't mind too much...  (Grin)

The following items were added beyond what the original program
documentation claimed it could do (therefore warranting a new version
number):

o High dithering was added (no small thing!)
o STe 4,096 palette support was added (harder still!)
o The plotter routine has been accelerated, so pictures take
  less time to convert.
o Scaling factors are now checked.
o The program automatically suggests the best dithering mode.
o The display has been cleaned up a little.
o SPU2SPC was included.
o You can now abort conversions while the GIF is being unblocked.
  In the previous version you had to wait until the unblocking
  was finished.

Bugs:

Hopefully I've fixed them all.  If you find any that I don't, let
me know!  And if you want to drop me a line with a suggestion for
improvements to this program, or have an idea for a program you'd
like to see, send me a letter!  Mail is taking about 20 days to
go to Germany and back, so don't panic if I don't answer in a week.
I usually mail my replies a few days after I receive correspondence.

The only thing that might be buggy is the STe palette support.  I
do not have an STe; however, looking at how the Spectrum display
routine works (marvelous piece of work) the only thing preventing
Spectrum pictures from having 4,096 colors is the fact that no program
supplies the information.  I have tested the results with the SPC_3375.PRG,
but I cannot be certain how it will look on an STe.  Would someone
please tell me how well this feature works?

SPU2SPC.PRG

This is a really simple program that converts uncompressed Spectrum
pictures (with the extension of SPU) to compressed Spectrum pictures
(with the extension of SPC).  This saves disk space.  I wrote this
program because the old version of DMJ GIF couldn't save in compressed
format, and I had several uncompressed pictures lying around and I
didn't feel like using the new version to convert from the original
GIF file.  To use this program, run it from any resolution.  Select
the Spectrum file you want to convert.  Then select the name for the
new file.  (If the new file already exists, you will be warned.)  The
picture will be converted, and then saved.  Then, if the old picture
hasn't been deleted (in the process of making the new one) you will be
asked if you want to delete the old one.  Just answer Yes or No from the
alert box.  Select Cancel from the first file selector to exit the
program.  Note that you can select compressed pictures as the source
picture; some programs save Spectrum pictures in compressed format, but
don't compress them properly.  The usual symptom of this is a file length
of 50014 bytes.  Using this program, you can compress them fully.
You can also enter "SPU" as the extension for the destination files.  That
way you can uncompress pictures as well.

SPC_3375.PRG

This is an even simpler program.  It lets you view Spectrum pictures,
and will "flicker" the colors to simulate 3,375 of the STe's 4,096 colors.
The flicker is reduced by changing each line on a different vertical
blank, so half the image flickers, then the other half, very quickly.
Since flickering is the only way to do it (short of a hardware modification)
if you want to view STe pictures you'll have to buy an STe or tolerate it.
(If the image doesn't use the STe palette, it will display normally.)

If you have comments or questions about this or any dmj software
product, please direct your enquiries to the address above.
Don't forget to include your name and address so I can get back
to you!

     -dmj

P.S.  Don't forget to check out View, a handy program that lets you
view pictures from the Desktop by double-clicking them.
